--- vlc.win32.nsi	Thu Sep 13 21:25:24 2007
+++ vlc.win32.nsi	Thu Sep 13 21:27:35 2007
@@ -81,26 +81,42 @@
     !insertmacro MUI_UNPAGE_INSTFILES
     !insertmacro MUI_UNPAGE_FINISH
 
+  ; builds a language list looking like ":ID: 'short' :ID: 'short' ..."
+  !macro ADD_LANGUAGE _long _short
+    !insertmacro MUI_LANGUAGE ${_long}
+
+    !ifndef LANG_ID_NAME
+      !define LANG_ID_NAME ":${LANG_${_long}}: '${_short}'"
+    !else
+      !ifdef LANG_ID_NAME_TEMP
+        !undef LANG_ID_NAME_TEMP
+      !endif
+      !define LANG_ID_NAME_TEMP "${LANG_ID_NAME}"
+      !undef LANG_ID_NAME
+      !define LANG_ID_NAME ":${LANG_${_long}}: '${_short}' ${LANG_ID_NAME_TEMP}"
+    !endif
+  !macroend
+
 ; Language files
-  !insertmacro MUI_LANGUAGE "English" # first language is the default language
-  !insertmacro MUI_LANGUAGE "French"
-  !insertmacro MUI_LANGUAGE "German"
-  !insertmacro MUI_LANGUAGE "Spanish"
-  !insertmacro MUI_LANGUAGE "SimpChinese"
-  !insertmacro MUI_LANGUAGE "TradChinese"
-  !insertmacro MUI_LANGUAGE "Japanese"
-  !insertmacro MUI_LANGUAGE "Korean"
-  !insertmacro MUI_LANGUAGE "Italian"
-  !insertmacro MUI_LANGUAGE "Dutch"
-  !insertmacro MUI_LANGUAGE "Danish"
-  !insertmacro MUI_LANGUAGE "Swedish"
-  !insertmacro MUI_LANGUAGE "Norwegian"
-  !insertmacro MUI_LANGUAGE "Finnish"
-  !insertmacro MUI_LANGUAGE "Greek"
-  !insertmacro MUI_LANGUAGE "Russian"
-  !insertmacro MUI_LANGUAGE "Portuguese"
-  !insertmacro MUI_LANGUAGE "Arabic"
-  !insertmacro MUI_LANGUAGE "Polish"
+  !insertmacro ADD_LANGUAGE "English"     "en" # first language is the default language
+  !insertmacro ADD_LANGUAGE "French"      "fr"
+  !insertmacro ADD_LANGUAGE "German"      "de"
+  !insertmacro ADD_LANGUAGE "Spanish"     "es"
+  !insertmacro ADD_LANGUAGE "SimpChinese" "zh_CN"
+  !insertmacro ADD_LANGUAGE "TradChinese" "zh_TW"
+  !insertmacro ADD_LANGUAGE "Japanese"    "ja"
+  !insertmacro ADD_LANGUAGE "Korean"      "ko"
+  !insertmacro ADD_LANGUAGE "Italian"     "it"
+  !insertmacro ADD_LANGUAGE "Dutch"       "nl"
+  !insertmacro ADD_LANGUAGE "Danish"      "da"
+  !insertmacro ADD_LANGUAGE "Swedish"     "sv"
+  !insertmacro ADD_LANGUAGE "Norwegian"   "no"
+  !insertmacro ADD_LANGUAGE "Finnish"     ""
+  !insertmacro ADD_LANGUAGE "Greek"       "el"
+  !insertmacro ADD_LANGUAGE "Russian"     "ru"
+  !insertmacro ADD_LANGUAGE "Portuguese"  "pt_PT"
+  !insertmacro ADD_LANGUAGE "Arabic"      "ar"
+  !insertmacro ADD_LANGUAGE "Polish"      "pl"
 
 !insertmacro MUI_RESERVEFILE_LANGDLL
 
@@ -552,6 +568,62 @@
   !insertmacro MUI_LANGDLL_DISPLAY
 FunctionEnd
 
+Var vlcrc
+Function SaveLanguage
+  Push $R0
+  Push $R1
+  Push $R2
+  Push $R3
+  Push $R4
+
+  ReadRegStr $R4 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" AppData
+  StrCpy $R4 "$R4\vlc\vlcrc"
+  IfFileExists $R4 done
+
+  ;search-string
+  StrCpy $R0 $LANGUAGE
+  StrCpy $R0 ":$R0:"
+  ;counter
+  StrCpy $R1 0
+  ;string-length
+  StrLen $R2 $R0
+loop:
+  StrCpy $R3 "${LANG_ID_NAME}" $R2 $R1
+  StrCmp $R3 "" done
+  IntOp $R1 $R1 + 1
+  StrCmp $R3 $R0 "" loop
+
+  IntOp $R1 $R1 + $R2
+  IntOp $R1 $R1 + 1
+  ;start of result
+  StrCpy $R2 $R1
+loop2:
+  StrCpy $R3 "${LANG_ID_NAME}" 1 $R1
+  StrCmp $R3 "" done
+  IntOp $R1 $R1 + 1
+  StrCmp $R3 "'" "" loop2
+  IntOp $R1 $R1 - 1
+  IntCmp $R1 0 done
+  IntOp $R1 $R1 - $R2
+  ;result
+  StrCpy $R0 "${LANG_ID_NAME}" $R1 $R2
+
+  ReadRegStr $R1 HKCU "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" AppData
+  StrCpy $R1 "$R1\vlc"
+  CreateDirectory "$R1"
+  FileOpen $vlcrc "$R4" w
+  FileWrite $vlcrc "[main]$\r$\n"
+  FileWrite $vlcrc "language=$R0$\r$\n"
+  FileClose $vlcrc
+
+done:
+  Pop $R4
+  Pop $R3
+  Pop $R2
+  Pop $R1
+  Pop $R0
+FunctionEnd
+
 Section -Post
   WriteUninstaller "$INSTDIR\uninstall.exe"
   WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "InstallDir" $INSTDIR
@@ -570,6 +642,8 @@
     "URLInfoAbout" "${PRODUCT_WEB_SITE}"
   WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" \
     "Publisher" "${PRODUCT_PUBLISHER}"
+
+  call SaveLanguage
 SectionEnd
 
 ;;;;;;;;;;;;;;;;;;;;;;;;
